#ifndef __BOX__
#define __BOX__

#include "interval.h"
#include "iboolean.h"
#include <iostream>

class Box
{
private:
    // Interval vector data.
    Interval* data;
    // dimension of Interval vector data
    int dim;

public:
    // Constructor
    Box ();
    Box (int);
    Box (Interval, Interval);
    Box (Interval, Interval, Interval);
    Box (const Box&);
    // Destructor.
    ~Box ();

    // Members Overloaded Operators
    Interval& operator[] (int i)  const;
    Box& operator=(const Box &b);
    // Other Overloaded Operators
    friend std::ostream& operator<<(std::ostream& os, const Box&);
    friend Box	operator+(const Box&,const Box&);
    friend Box	operator-(const Box&);
    friend Box	operator-(const Box&,const Box&);
    friend Box	operator*(const Interval&,const Box&);
    friend Box	operator*(const Box&,const Interval&);
    // Other Members
    int      getDim();
    bool     isEmpty() const;
    int      mainAxis() const;
    double   volume () const;
    double   width() const;
    // Friends Functions
    friend void Bisect (Box&, Box&, Box&);
    friend void BisectAlong (Box&, Box&, Box&, int);
};

#endif
