%{
#include <iostream>
#include <string.h>
#include "syntax_tree.h"
%}

BLANCS		[\t]+
DIGIT 		[0-9]
INTEGER		{DIGIT}+
REEL			{INTEGER}("."{INTEGER})?
LETTER		[A-Za-z]
VARIABLE		{LETTER}({LETTER}|{DIGIT})*

%%
{REEL} { yylval.name=QString(yytext);  return(tk_real);}
[-+*/()]         { yylval.name=QString(yytext); return *yytext;}
([Ss]"in")|"SIN"   { yylval.name="sin" ;  return(tk_function); }
([Cc]"os")|"COS"   { yylval.name="cos" ;  return(tk_function);}
([Ee]"xp")|"EXP"   { yylval.name="exp" ; return(tk_function);}
([Ll]"n")|"LN"	 { yylval.name="ln" ; return(tk_function);}
([Ss]"qrt")|"SQRT" { yylval.name="sqrt" ; return(tk_function);}
([Ss]"qr")|"SQR"   { yylval.name="sqr" ; return(tk_function);}
{VARIABLE} {yylval.name=QString(yytext); return(tk_variable);}
%%

int yywrap(void) {return 1 ;}
