#ifndef WINDOW_H
#define WINDOW_H

#include <QWidget>
#include <QPushButton>
#include <QDoubleSpinBox>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QLabel>
#include <QCheckBox>
#include "frame.h"

class Window : public QWidget
{
    Q_OBJECT

public:
    Window();
    ~Window();

    void createControls(const QString &title);
    void createFunctionEdit(const QString &title);
    void createConnections();

public slots:
    void compute();

public:
    QCheckBox *stepbystepCheck;
    QDoubleSpinBox *precisionSpinBox;

    QPushButton *bgo;
    QPushButton *bexit;

    QLabel *pavage1Label;
    QLabel *precisionLabel;

    QGroupBox *controlsGroup;
    QHBoxLayout *controlsLayout;

    QLineEdit *functionEdit;
    QGroupBox *functionGroup;
    QGridLayout *functionLayout;

};


#endif // WINDOW_H


